var rightLinks = {
	pu: rightLinksPrefUtils,

	gEnabled: true,
	gStopContextMenu: false,
	gRunned: false,
	gType: null,
	gLink: null,
	origItem: null,
	gXULNS: "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul",
	gShowContextTimeout: null,
	gEvent: {},
	gOrigJSLinksInBg: false,
	init: function() {
		this._log("window loaded");
		window.removeEventListener("load", this, false);
		window.addEventListener("unload", this, false);

		this.setListeners(["mousedown", "mouseup", "click", "contextmenu"], true);
		this._log("setListeners done");
		this.pu.init();
		this._log("Pref utils initialized");
		this.setStatus();
		this.setItemsMode();
		this.registerHotkeys();
		this._log("Initialization done");
	},
	destroy: function() {
		window.removeEventListener("unload", this, false);
		this.setListeners(["mousedown", "mouseup", "click", "contextmenu"], false);
		this.cancelDelayedContext();
		this.pu.destroy();
	},
	handleEvent: function(e) {
		switch(e.type) {
			case "load":        this.init(e);               break;
			case "unload":      this.destroy(e);            break;
			case "mousedown":   this.mousedownHandler(e);   break;
			case "mouseup":     this.mouseupHandler(e);     break;
			case "click":       this.clickHandler(e);       break;
			case "contextmenu": this.contextmenuHandler(e); break;
			case "mousemove":   this.mousemoveHandler(e);
		}
	},
	setListeners: function(evtTypes, addFlag) {
		var act = addFlag ? "addEventListener" : "removeEventListener";
		evtTypes.forEach(function(evtType) {
			window[act](evtType, this, true);
		}, this);
	},
	isVoidURI: function(uri) {
		uri = (uri || "").replace(/(?:\s|%20)+/g, " ");
		return /^javascript: *(?:|\/\/|void *(?: +0|\( *0 *\))) *;? *$/i.test(uri);
	},
	isJSURI: function(uri) {
		return typeof uri == "string" && /^javascript:/i.test(uri);
	},
	isDummyURI: function(item, uri, evt) {
		//if(this.gType != "link")
		//	return false;
		item = item || this.gLink;
		uri = uri || this.getHref(item, evt || this.gEvent);
		var doc = item.ownerDocument;
		var loc = doc.location.href.replace(/#.*$/, "");
		if(uri.indexOf(loc) != 0)
			return false;
		var _uri = uri.substr(loc.length);
		if(_uri == "" && item.getAttribute && item.hasAttribute("href") && !item.getAttribute("href")) // <a href="">
			return true;
		if(_uri.charAt(0) != "#")
			return false;
		var anchor = _uri.substr(1);
		return !anchor || (!doc.getElementById(anchor) && !doc.getElementsByName(anchor).length);
	},
	get mi() {
		return document.getElementById("rightLinks-toggleStatus-mi");
	},
	get status() {
		return document.getElementById("rightLinks-toggleStatus-status");
	},
	get tbb() {
		return document.getElementById("rightLinks-toggleStatus-tbutton");
	},
	get paletteButton() {
		var tb = "gNavToolbox" in window && gNavToolbox
			|| "getNavToolbox" in window && getNavToolbox() // Firefox 3.0
			|| document.getElementById("navigator-toolbox"); // Firefox <= 2.0
		if(!tb || !("palette" in tb))
			return null;
		var elt = tb.palette.getElementsByAttribute("id", "rightLinks-toggleStatus-tbutton");
		return elt.length ? elt[0] : null;
	},
	get appInfo() {
		delete this.appInfo;
		return this.appInfo = Components.classes["@mozilla.org/xre/app-info;1"]
			.getService(Components.interfaces.nsIXULAppInfo);
	},
	get isSeaMonkey() {
		delete this.isSeaMonkey;
		return this.isSeaMonkey = this.appInfo.name == "SeaMonkey";
	},
	get fxVersion() {
		var ver = parseFloat(this.appInfo.version); // 3.0 for "3.0.10"
		if(this.isSeaMonkey) switch(ver) {
			case 2:             ver = 3.5; break;
			case 2.1: default:  ver = 3.7;
		}
		delete this.fxVersion;
		return this.fxVersion = ver;
	},
	getLink: function(e) {
		if(e.button != 2 || e.ctrlKey || e.shiftKey || e.altKey || e.metaKey || !this.gEnabled)
			return null;
		var a = e.originalTarget;
		if(!a.localName) // a === document
			return null;
		var aln = a.localName.toLowerCase();
		var _a, _aln;

		// Bookmark
		if(
			this.pu.pref("enabledOnBookmarks")
			&& a.namespaceURI == this.gXULNS
			&& a.type != "menu"
			&& (
				(
					/(?:^|\s)bookmark-item(?:\s|$)/.test(a.className)
					&& (aln == "toolbarbutton" || aln == "menuitem")
				)
				|| (aln == "menuitem" && (a.hasAttribute("siteURI")))
				|| (aln == "treechildren" && (a.parentNode.id || "").indexOf("bookmark") != -1) // Sidebar
			)
			&& !this.hasParent(a, "goPopup")
			&& this.getBookmarkURI(a, e)
		) {
			this.gType = "bookmark";
			return a;
		}

		// History item:
		if(
			this.pu.pref("enabledOnHistoryItems")
			&& a.namespaceURI == this.gXULNS
			&& (
				this.hasParent(a, "goPopup")
				|| (aln == "treechildren" && (a.parentNode.id || "").indexOf("history") != -1) // Sidebar
			)
			&& this.getBookmarkURI(a, e)
		) {
			this.gType = "historyItem";
			return a;
		}

		// Link:
		const docNode = Node.DOCUMENT_NODE; // 9
		const eltNode = Node.ELEMENT_NODE; // 1
		for(_a = a; _a && _a.nodeType != docNode; _a = _a.parentNode) {
			// https://bugzilla.mozilla.org/show_bug.cgi?id=266932
			// https://bug266932.bugzilla.mozilla.org/attachment.cgi?id=206815
			// It's strange to see another link in Status Bar
			// and other browsers (Opera, Safari, Google Chrome) will open "top level" link.
			// And IE... IE won't open XML (it's important!) testcase. :D
			// Also this seems like bug of left-click handler.
			// So, let's open link, which user see in Status Bar.
			if(
				(
					_a instanceof HTMLAnchorElement
					|| _a instanceof HTMLAreaElement
					|| _a instanceof HTMLLinkElement
				) && _a.hasAttribute("href")
				|| _a.nodeType == eltNode && _a.hasAttributeNS("http://www.w3.org/1999/xlink", "href")
			) {
				this.gType = "link";
				return _a;
			}
		}

		// img:
		if(this.pu.pref("enabledOnImages")) {
			if(aln == "_moz_generated_content_before") { // Alt-text
				_a = a.parentNode;
				_aln = _a.localName.toLowerCase();
			}
			else {
				_a = a;
				_aln = aln;
			}
			if(
				(
					(_aln == "img" || _aln == "image") && _a.hasAttribute("src")
					|| _a instanceof HTMLCanvasElement
				)
				&& !(_a.ownerDocument.defaultView instanceof Components.interfaces.nsIDOMChromeWindow) // Not for interface...
			) {
				this.gType = "img";
				return _a;
			}
		}

		return null;
	},
	hasParent: function(it, pId) {
		for(it = it.parentNode; it; it = it.parentNode)
			if(it.id == pId)
				return true;
		return false;
	},
	getBookmarkURI:	function(it, e, usePlacesURIs) {
		var ln = it.localName;
		var uri = ln && ln.toLowerCase() == "treechildren"
			? this.getTreeInfo(it, e, "uri")
			: it.statusText
				|| (it.node && it.node.uri)
				|| (it._placesNode && it._placesNode.uri) // Firefox 3.7a5pre
				|| it.getAttribute("siteURI")
				|| "";
		return !usePlacesURIs && /^place:/.test(uri) ? "" : uri;
	},
	getTreeInfo: function(treechildren, e, prop) { // "uri" or "title"
		if(!("PlacesUtils" in window)) // For Firefox 3.0+
			return "";
		var tree = (treechildren || this.gLink).parentNode
		e = e || this.gEvent;

		// Based on code of Places' Tooltips ( https://addons.mozilla.org/firefox/addon/7314 )
		var row = {}, column = {}, part = {};
		var tbo = tree.treeBoxObject;
		tbo.getCellAt(e.clientX, e.clientY, row, column, part);
		if(row.value == -1)
			return "";
		var node = tree.view.nodeForTreeIndex(row.value);
		if(!PlacesUtils.nodeIsURI(node))
			return "";
		return node[prop];
	},
	getLinkURI: function(it) {
		const ns = "http://www.w3.org/1999/xlink";
		return it.hasAttributeNS(ns, "href")
			// See chrome://browser/content/utilityOverlay.js
			? makeURLAbsolute(it.baseURI, it.getAttributeNS(ns, "href"))
			: it.href;
	},
	getHref: function(a, e) {
		a = a || this.gLink;
		e = e || this.gEvent;
		return this.getLinkURI(a)
			|| a.src
			|| a instanceof HTMLCanvasElement && a.toDataURL()
			|| this.getBookmarkURI(a, e, "uri");
	},
	closeMenus: function(it) {
		it = it || this.gLink;
		if(it && typeof it == "object")
			closeMenus(it); // chrome://browser/content/utilityOverlay.js
	},
	stopEvent: function(e) {
		e.preventDefault();
		e.stopPropagation();
	},

	mousedownHandler: function(e) {
		this._log("Mousedown, enabled: " + this.gEnabled);
		if(!this.gEnabled)
			return;

		this.gLink = this.getLink(e);
		this._log("Mousedown, link: " + this.gLink, "type: " + this.gType);
		this.origItem = e.originalTarget;
		this.gRunned = false;
		this.gStopContextMenu = !!this.gLink;
		if(!this.gLink)
			return;
		var clone = {};
		for(var p in e) // Firefox 1.5.0.x and 2.0.0.x bug
			clone[p] = e[p];
		this.gEvent = clone;
		this.saveXY(e);
		var cmt = this.pu.pref("showContextMenuTimeout");
		if(cmt > 0) {
			this.cancelDelayedContext();
			this.gShowContextTimeout = setTimeout(
				function(_this) {
					_this.gRunned = true;
					_this.showContextMenu();
				},
				cmt,
				this
			);
		}

		this.removeMoveHandler();
		this.disallowMousemove = this.pu.pref("disallowMousemoveDist") >= 0;
		this.mousemoveParams = {
			dist: 0,
			screenX: e.screenX,
			screenY: e.screenY
		};
		window.addEventListener("mousemove", this, true);
	},
	mouseupHandler: function(e) {
		if(!this.gEnabled)
			return;
		this.saveXY(e);
		this.removeMoveHandler();
		/*
		setTimeout(function(_this) {
			_this.gRunned = false;
			_this.gStopContextMenu = false;
			_this.removeMoveHandler();
		}, 0, this);
		*/
	},
	clickHandler: function(e) {
		if(!this.gEnabled || this.gRunned)
			return;

		var a = this.getLink(e);
		this._log("Click, link: " + a);
		if(!a)
			return;
		var href = this.getHref(a, e);
		if(!href)
			return;
		this.stopEvent(e);
		this.cancelDelayedContext();
		this.gLink = a;
		this.origItem = e.originalTarget;
		if((this.gType == "bookmark" || this.gType == "historyItem") && this.pu.pref("closePopups"))
			this.closeMenus(a);

		this._log("Click, try open link...");

		var voidURI = this.isVoidURI(href);
		if(!voidURI && this.isJSURI(href)) {
			var _this = this;
			var loadJSFunc = function() { _this.loadJSLink(); };
			var loadJS = this.pu.pref("loadJavaScriptLinks");
			if(this.pu.pref("notifyJavaScriptLinks"))
				this.notify(
					this.getLocalized("title"),
					this.getLocalized("JavaScriptLink" + (loadJS ? "" : "Click")),
					true,
					loadJS ? null : loadJSFunc
				);
			loadJS && loadJSFunc();
			return;
		}
		else if(voidURI || this.isDummyURI(a, href, e)) {
			var evts = this.createMouseEvents(e, a, ["mousedown", "mouseup", "click"], 0);

			var _this = this;
			var loadVoidFunc = function() {
				_this.setJSLinksBackgroundPolicy();
				evts();
				_this.restoreJSLinksBackgroundPolicy();
			};

			var loadVoid = this.pu.pref("loadVoidLinksWithHandlers");
			if(this.pu.pref("notifyVoidLinksWithHandlers"))
				this.notify(
					this.getLocalized("title"),
					this.getLocalized("clickHandler" + (loadVoid ? "" : "Click")),
					true,
					loadVoid ? null : loadVoidFunc
				);
			loadVoid && loadVoidFunc();
			return;
		}

		var tbr = gBrowser;
		var flp = this.pu.pref("filesLinksPolicy");
		if(flp > 0) { // 0 - not check, 1 - load in current tab, 2 - show context menu
			var rePref = "filesLinksMask";
			var re = this.pu.pref(rePref);
			if(re) {
				try {
					var _re = new RegExp(re, "i");
					if(_re.test(href)) {
						if(flp == 1)
							tbr.loadURI(href, this.getReferer());
						else
							this.showContextMenu();
						return;
					}
				}
				catch(e) {
					Components.utils.reportError(e);
					Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
						.getService(Components.interfaces.nsIPromptService)
						.alert(
							window,
							this.getLocalized("RegExpErrorTitle"),
							this.getLocalized("RegExpError")
								.replace("%r", re)
								.replace("%p", this.pu.prefNS + rePref)
								.replace("%e", e)
						);
				}
			}
		}

		if("Highlander" in window) { // https://addons.mozilla.org/firefox/addon/4086
			var tab = Highlander.findTabForURI(makeURI(href));
			if(tab) {
				Highlander.selectTab(tab);
				return;
			}
		}

		// Open a new tab as a child of the current tab (Tree Style Tab)
		// http://piro.sakura.ne.jp/xul/_treestyletab.html.en#api
		if((this.gType == "link" || this.gType == "img") && "TreeStyleTabService" in window)
			TreeStyleTabService.readyToOpenChildTab(gBrowser.selectedTab);

		var tab = tbr.addTab(href, this.getReferer());
		if(!this.pu.pref("loadInBackground"))
			tbr.selectedTab = tab;
	},
	contextmenuHandler: function(e) {
		if(this.gEnabled && this.gStopContextMenu)
			this.stopEvent(e), this._log("Contextmenu: stop event");
		else
			this._log("Contextmenu: allow event");
	},
	cancelDelayedContext: function() {
		clearTimeout(this.gShowContextTimeout);
	},
	mousemoveHandler: function(e) {
		this.saveXY(e);
		if(!this.disallowMousemove)
			return;
		var mp = this.mousemoveParams, x = e.screenX, y = e.screenY;
		this.mousemoveParams = {
			dist: mp.dist + Math.sqrt(
				Math.pow(mp.screenX - x, 2) +
				Math.pow(mp.screenY - y, 2)
			),
			screenX: x,
			screenY: y
		};
		if(this.mousemoveParams.dist < this.pu.pref("disallowMousemoveDist"))
			return;

		this._log("Mousemove: stop handling");

		this.gRunned = true;
		this.gStopContextMenu = false;
		this.cancelDelayedContext();

		this.removeMoveHandler();
	},
	removeMoveHandler: function() {
		window.removeEventListener("mousemove", this, true);
		this.mousemoveParams = null;
	},
	_xy: null,
	saveXY: function(e) {
		this._xy = {
			screenX: e.screenX,
			screenY: e.screenY,
			clientX: e.clientX,
			clientY: e.clientY,
			__proto__: null
		};
	},

	loadJSLink: function() {
		var disId = "dom.disable_open_during_load";
		var dis = this.pu.getPref(disId, true);
		this.pu.setPref(disId, false); // allow window.open( ... )
		this.setJSLinksBackgroundPolicy();

		var a = this.gLink;
		var href = this.getHref(a);
		if(this.gType == "bookmark" || this.gType == "historyItem")
			gBrowser.loadURI(href); // bookmarklets
		else
			a.ownerDocument.location.href = href; // frames?

		this.restoreJSLinksBackgroundPolicy();
		if(this.fxVersion >= 3) // Bug? And dispatchEvent does not works also (fx block new window)...
			setTimeout(function(_this) {
				_this.pu.setPref(disId, dis);
			}, 5, this); // And now pop-up blocker does not work... =/
		else
			this.pu.setPref(disId, dis);
	},
	setJSLinksBackgroundPolicy: function() {
		var bgId = "browser.tabs.loadDivertedInBackground";
		this.gOrigJSLinksInBg = this.pu.getPref(bgId, false);
		this.pu.setPref(bgId, this.pu.pref("loadJavaScriptLinksInBackground"));
	},
	restoreJSLinksBackgroundPolicy: function() {
		var origBg = this.gOrigJSLinksInBg;
		setTimeout(function(_this) { // For fx 3.0+
			_this.pu.setPref("browser.tabs.loadDivertedInBackground", origBg);
		}, 0, this);
	},
	getReferer: function() {
		// Must be undefined for Firefox 3.6+ - see addTab() method in chrome://browser/content/tabbrowser.xml
		return (this.gType == "link" || this.gType == "img") && this.pu.pref("sendReferer")
			? makeURI(this.gLink.ownerDocument.location.href) // see chrome://global/content/contentAreaUtils.js
			: undefined;
	},
	showContextMenu: function() {
		this.gStopContextMenu = false;
		this.createMouseEvents(
			this._xy || this.gEvent,
			this.origItem || this.gLink,
			["mousedown", "mouseup", "contextmenu"], 2
		)();
	},
	createMouseEvents: function(origEvt, item, evtTypes, button) {
		var evts = evtTypes.map(function(evtType) {
			return this.createMouseEvent(origEvt, item, evtType, button);
		}, this);
		var _this = this;
		return function() {
			_this.gEnabled = false;
			evts.forEach(function(evt) {
				item.dispatchEvent(evt);
			});
			_this.gEnabled = true;
		};
	},
	createMouseEvent: function(origEvt, item, evtType, button) {
		item = item || origEvt.originalTarget;
		var doc = item.ownerDocument;
		var evt = doc.createEvent("MouseEvents");
		evt.initMouseEvent( // https://developer.mozilla.org/en/DOM/event.initMouseEvent
			evtType, true /* canBubble */, true /* cancelable */, doc.defaultView, 1,
			origEvt.screenX, origEvt.screenY, origEvt.clientX, origEvt.clientY,
			false, false, false, false,
			button, null
		);
		return evt;
	},

	// GUI:
	toggleStatus: function(notify) {
		this.gEnabled = !this.gEnabled;
		this.pu.pref("enabled", this.gEnabled);
		this.setStatus(this.gEnabled);
		if(
			!notify
			|| this.isElementVisible(this.status)
			|| this.isElementVisible(this.tbb)
		)
			return;
		this.notify(
			this.getLocalized("title"),
			this.getLocalized(this.gEnabled ? "enabled" : "disabled"),
			this.gEnabled
		);
	},
	isElementVisible: function(elt) {
		if(!elt)
			return false;
		var bo = elt.boxObject;
		return bo.height > 0 && bo.width > 0;
	},
	setStatus: function(enabled) {
		if(enabled === undefined)
			enabled = this.pu.pref("enabled");
		this.gEnabled = enabled;
		var st = this.status;
		var stVal = enabled ? "enabled" : "disabled";
		st.setAttribute("rl_status", stVal);
		var tt = this.getLocalized("title") + " " + this.getLocalized(stVal);
		st.tooltipText = tt;
		this.mi.setAttribute("checked", enabled);
		var tbb = this.tbb || this.paletteButton;
		if(!tbb)
			return;
		tbb.setAttribute("rl_status", stVal);
		tbb.tooltipText = tt;
		if(this.pu.pref("ui.toolbarbuttonCheckedStyle")) {
			tbb.setAttribute("type", "checkbox");
			tbb.setAttribute("checked", enabled);
		}
		else {
			tbb.removeAttribute("type");
			tbb.removeAttribute("checked");
		}
	},
	setItemsMode: function() {
		this.mi    .collapsed = !this.pu.pref("ui.showInToolsMenu");
		this.status.collapsed = !this.pu.pref("ui.showInStatusbar");
	},
	notify: function(ttl, txt, enabledImg, fnc) {
		var dur = this.pu.pref("notifyOpenTime");
		if(dur < 0)
			 return;
		if(enabledImg === undefined)
			enabledImg = true;
		window.openDialog(
			 "chrome://rightlinks/content/notify.xul",
			 "_blank",
			 "chrome,dialog=1,titlebar=0,popup=1",
			 dur, ttl, txt, enabledImg, fnc
		);
	},

	readPrefs: function(popup) {
		popup = popup || document.getElementById("rightLinks-settingsPopup");
		var closeMenu = this.pu.pref("ui.closeMenu") ? "auto" : "none";
		Array.forEach(
			popup.getElementsByAttribute("rl_pref", "*"),
			function(mi) {
				mi.setAttribute("closemenu", closeMenu);
				this.setPref(mi, true);
			},
			this
		);
		Array.forEach(
			popup.getElementsByAttribute("rl_depends", "*"),
			function(dep) {
				dep.setAttribute(
					"disabled",
					!Array.some(
						popup.getElementsByAttribute("rl_requiredFor", dep.getAttribute("rl_depends")),
						function(req) {
							return req.getAttribute("checked") == "true";
						}
					)
				);
			}
		);
		var mi = popup.getElementsByAttribute("rl_pref", "ui.toolbarbuttonCheckedStyle")[0];
		if(this.isElementVisible(this.tbb)) {
			mi.removeAttribute("hidden");
			mi.nextSibling.removeAttribute("hidden");
		}
		else {
			mi.setAttribute("hidden", "true");
			mi.nextSibling.setAttribute("hidden", "true");
		}
	},
	setPref: function(mi, readFlag) {
		var pName = mi.getAttribute("rl_pref");
		if(!pName)
			throw new Error("[Right Links]: Can't get pref name for " + mi.getAttribute("label"));
		if(readFlag) {
			mi.setAttribute("checked", !!this.pu.pref(pName));
			return;
		}
		this.pu.pref(pName, mi.getAttribute("checked") == "true");
		if(!this.pu.pref("ui.closeMenu"))
			this.readPrefs();
	},
	prefsChanged: function(pName, pVal) {
		switch(pName) {
			case "ui.toolbarbuttonCheckedStyle":
			case "enabled":
				this.setStatus();
			break;
			case "ui.showInToolsMenu":
			case "ui.showInStatusbar":
				this.setItemsMode();
		}
	},

	get strings() {
		delete this.strings;
		return this.strings = document.getElementById("rightLinks-strings");
	},
	getLocalized: function(id) {
		return this.strings.getString(id);
	},

	// Hotkeys:
	registerHotkeys: function() {
		this.pu.prefSvc.getBranch(this.pu.prefNS + "key.")
			.getChildList("", {})
			.forEach(this.registerHotkey, this);
	},
	registerHotkey: function(kId) {
		var keyStr = this.pu.pref("key." + kId);
		if(!keyStr) // Key is disabled
			return;
		var tokens = keyStr.split(" ");
		var key = tokens.pop() || " ";
		var modifiers = tokens.join(",");
		var kElt = document.getElementById("rightLinks-key-" + kId);
		kElt.removeAttribute("disabled");
		kElt.setAttribute(key.indexOf("VK_") == 0 ? "keycode" : "key", key);
		kElt.setAttribute("modifiers", modifiers);
	},

	get consoleSvc() {
		delete this.consoleSvc;
		return this.consoleSvc = Components.classes["@mozilla.org/consoleservice;1"]
			.getService(Components.interfaces.nsIConsoleService);
	},
	_log: function() {
		this.consoleSvc.logStringMessage("[Right Links]: " + Array.map(arguments, String).join("\n"));
	}
};
rightLinks._log("addEventListener for \"load\" event");
window.addEventListener("load", rightLinks, false);